using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserOrder;
namespace CMSMicroservice.Protobuf.Validator.UserOrder;

public class DeleteUserOrderRequestValidator : AbstractValidator<DeleteUserOrderRequest>
{
    public DeleteUserOrderRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeleteUserOrderRequest>.CreateWithOptions((DeleteUserOrderRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
